/*
 * Copyright (c) 2017 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.stack.primitive;

import org.eclipse.collections.api.block.function.primitive.BooleanToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.BooleanPredicate;
import org.eclipse.collections.api.list.primitive.BooleanList;
import org.eclipse.collections.api.stack.MutableStack;

/**
 * This file was automatically generated from template file mutablePrimitiveStack.stg.
 *
 * @since 3.0.
 */
public interface MutableBooleanStack extends BooleanStack
{
    /**
     * Adds an item to the top of the stack.
     */
    void push(boolean item);

    /**
     * Removes and returns the top element of the stack.
     */
    boolean pop();

    /**
     * Removes and returns a BooleanList of the number of elements specified by the count, beginning with the top of the stack.
     */
    BooleanList pop(int count);

    /**
     * Clears the Stack
     */
    void clear();

    @Override
    MutableBooleanStack select(BooleanPredicate predicate);

    @Override
    MutableBooleanStack reject(BooleanPredicate predicate);

    @Override
    <V> MutableStack<V> collect(BooleanToObjectFunction<? extends V> function);

    MutableBooleanStack asUnmodifiable();

    MutableBooleanStack asSynchronized();
}
